'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var dotProp = _interopDefault(require('dot-prop'));

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

function isObject(obj) {
  return Object.prototype.toString.call(obj) === '[object Object]';
}

function _append(arr, item) {
  return arr.concat(item);
}

function _prepend(arr, item) {
  return [item].concat(arr);
}

var IMS = function () {
  function IMS() {
    var initialState = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
    classCallCheck(this, IMS);

    if (!isObject(initialState)) {
      throw new Error('[IMS] Initial state is required to be an Object.');
    }
    this.state = initialState;
  }

  createClass(IMS, [{
    key: 'get',
    value: function get(key) {
      return dotProp.get(this.state, key);
    }
  }, {
    key: 'set',
    value: function set(key, value) {
      dotProp.set(this.state, key, value);
      return this;
    }
  }, {
    key: 'key',
    value: function key(_key) {
      var state = this.state;
      var value = dotProp.get(this.state, _key);

      return {
        append: function append(item) {
          dotProp.set(state, _key, _append(value, item));
        },
        prepend: function prepend(item) {
          dotProp.set(state, _key, _prepend(value, item));
        },
        first: function first(length) {
          return length ? value.slice(0, length) : value[0];
        },
        last: function last(length) {
          return length ? value.slice(-length) : value[value.length - 1];
        }
      };
    }
  }]);
  return IMS;
}();

module.exports = IMS;